"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const FieldMetadata_1 = require("../metadata/FieldMetadata");
const storage_1 = require("../storage");
const ArgumentMetadata_1 = require("../metadata/ArgumentMetadata");
function Field(typeFunc) {
    return (prototype, propertyName, descriptor) => {
        const argumentMetadata = new ArgumentMetadata_1.ArgumentMetadata(prototype, propertyName);
        const fieldMetadata = new FieldMetadata_1.FieldMetadata(propertyName, typeFunc, argumentMetadata, descriptor);
        storage_1.getTypeMetadata(prototype).addFieldMetadata(propertyName, fieldMetadata);
    };
}
exports.Field = Field;
//# sourceMappingURL=Field.js.map