"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
const storage_1 = require("../storage");
class ArgumentMetadata {
    constructor(typeClassPrototype, fieldName) {
        this.getLiteral = () => {
            if (!this.argumentType)
                return '';
            const argumentTypeFieldMap = storage_1.getTypeMetadata(this.argumentType.prototype).fieldMetadataMap;
            const argumentLiterals = Object.keys(argumentTypeFieldMap).map(argumentName => {
                return argumentTypeFieldMap[argumentName].getLiteral();
            });
            return argumentLiterals.length ? `(${argumentLiterals.join(', ')})` : '';
        };
        const argumentTypes = Reflect.getMetadata('design:paramtypes', typeClassPrototype, fieldName);
        if (argumentTypes && argumentTypes[1]) {
            this.argumentType = argumentTypes[1];
        }
    }
}
exports.ArgumentMetadata = ArgumentMetadata;
//# sourceMappingURL=ArgumentMetadata.js.map