"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const storage_1 = require("../storage");
class TypeStructure {
    constructor(type) {
        const typeMetadata = storage_1.getTypeMetadata(type.prototype);
        this.name = type.name;
        this.literals = [typeMetadata.getLiteral()];
        this.resolvers = {};
        this.mutations = {};
        Object.values(typeMetadata.fieldMetadataMap).forEach(fieldMetadata => {
            if (fieldMetadata.isMutation) {
                this.mutations[fieldMetadata.name] = fieldMetadata.resolver;
                this.literals.push(fieldMetadata.getLiteral());
            }
            else if (fieldMetadata.resolver) {
                this.resolvers[fieldMetadata.name] = fieldMetadata.resolver;
            }
        });
    }
}
exports.TypeStructure = TypeStructure;
//# sourceMappingURL=TypeStructure.js.map